#ifndef __WINAMP2_H
#define __WINAMP2_H

#include "player.h"
#include "../VTK/BangManager.h"

#define WC_WINAMP2		"Winamp v1.x"
#define WC_WINAMP2_PE	"Winamp PE"

// implemented

#define WINAMP_ADDFILES2PL				'l'

#define WINAMP_PLAYCD					40323

#define WINAMP_PREVSONG					40044
#define WINAMP_PLAY						40045
#define WINAMP_PAUSE					40046
#define WINAMP_STOP						40047
#define WINAMP_NEXTSONG					40048
#define WINAMP_FILE_PLAY                40029
#define WINAMP_FILE_QUIT                40001
#define WINAMP_FILE_REPEAT              40022
#define WINAMP_FILE_SHUFFLE             40023
#define WINAMP_OPTIONS_AOT              40019
#define WINAMP_RELOAD_SKIN				40291
#define WINAMP_FFWD5S                   40060
#define WINAMP_REW5S                    40061
#define WINAMP_VOLUMEUP                 40058
#define WINAMP_VOLUMEDOWN               40059
#define WINAMP_BUTTON4_SHIFT			40147
#define WINAMP_OPEN_LOC					40155
#define WINAMP_OPTIONS_DSIZE			40165
#define WINAMP_OPTIONS_PREFS			40012
#define WINAMP_FILE_DIR                 40187
#define WINAMP_HIGH_PRIORITY            40025
#define WINAMP_OPTIONS_EQ               40036
#define WINAMP_OPTIONS_ELAPSED          40037
#define WINAMP_OPTIONS_REMAINING        40038
#define WINAMP_OPTIONS_PLEDIT           40040
#define WINAMP_HELP_ABOUT               40041
#define WINAMP_MAINMENU                 40043
#define WINAMP_NEXT_WINDOW              40063
#define WINAMP_OPTIONS_WINDOWSHADE      40064
#define WINAMP_BUTTON1_SHIFT            40144
#define WINAMP_BUTTON2_SHIFT            40145
#define WINAMP_BUTTON3_SHIFT            40146
#define WINAMP_BUTTON5_SHIFT            40148
#define WINAMP_LIST_START				40154
#define WINAMP_BUTTON3_CTRL             40156
#define WINAMP_BUTTON4_CTRL             40157
#define WINAMP_LIST_END					40158
#define IDC_SORT_FILENAME               40166
#define IDC_SORT_FILETITLE              40167
#define IDC_SORT_ENTIREFILENAME         40168
#define IDC_SELECTALL                   40169
#define IDC_SELECTNONE                  40170
#define IDC_SELECTINV                   40171
#define IDM_EQ_LOADPRE                  40172
#define IDM_EQ_LOADMP3                  40173
#define IDM_EQ_LOADDEFAULT              40174
#define IDM_EQ_SAVEPRE                  40175
#define IDM_EQ_SAVEMP3                  40176
#define IDM_EQ_SAVEDEFAULT              40177
#define IDM_EQ_DELPRE                   40178
#define IDM_EQ_DELMP3                   40180
#define IDC_PLAYLIST_PLAY               40184
#define WINAMP_FILE_LOC                 40185
#define WINAMP_OPTIONS_EASYMOVE         40186
#define WINAMP_EDIT_ID3                 40188
#define WINAMP_TOGGLE_AUTOSCROLL        40189
#define WINAMP_VISSETUP                 40190
#define WINAMP_PLGSETUP                 40191
#define WINAMP_VISPLUGIN                40192
#define WINAMP_JUMPTIME                 40193
#define WINAMP_JUMPFILE                 40194
#define WINAMP_JUMP10FWD                40195
#define WINAMP_JUMP10BACK               40197
#define WINAMP_REWIND					40198
#define WINAMP_PLAYLIST_WINDOWSHADE		40266
#define WINAMP_MINIBROWSER_TOGGLE		40298
#define WINAMP_OPTIONS_SKINS			40219
#define WINAMP_USER_SETVOLUME			122
#define WINAMP_USER_SETPANNING			123
#define WINAMP_USER_BITRATE				126
#define WINAMP_USER_SONGPOSITION		105
#define WINAMP_USER_SONGSEEK			106
#define WINAMP_USER_RESTART				135
#define WINAMP_USER_STATUS				104

// class for handling wa2

class wa2 : public Player
{
public:
	wa2();
	~wa2();

	HWND GetPlayerWnd();
	void powerOff();

	void repeat();
	void shuffle();

	void prev();
	void play();
	void pause();
	void stop();
	void next();

	void volumeUp();
	void volumeDown();
	void forward5s();
	void rewind5s();

	void loadDir();
	void prefs();

	void onTop();
	void loadFile();

	static int position;

	// specific wa2 commands:

	static void Bang_OpenLoc(HWND caller, LPCSTR args);
	static void Bang_AddToPlaylist(HWND caller, LPCSTR args);
	static void Bang_StopFade(HWND caller, LPCSTR args);
	static void Bang_StopAfterTrack(HWND caller, LPCSTR args);
	static void Bang_PlayCD(HWND caller, LPCSTR args);
	static void Bang_ReloadSkin(HWND caller, LPCSTR args);
	static void Bang_DoubleSize(HWND caller, LPCSTR args);
	static void Bang_TimeElapsed(HWND caller, LPCSTR args);
	static void Bang_TimeRemaining(HWND caller, LPCSTR args);
	static void Bang_AddSong(HWND caller, LPCSTR args);
	static void Bang_About(HWND caller, LPCSTR args);
	static void Bang_EasyMove(HWND caller, LPCSTR args);
	static void Bang_Eq(HWND caller, LPCSTR args);
	static void Bang_Jump10Back(HWND caller, LPCSTR args);
	static void Bang_Jump10Fwd(HWND caller, LPCSTR args);
	static void Bang_JumpToFile(HWND caller, LPCSTR args);
	static void Bang_JumpToTime(HWND caller, LPCSTR args);
	static void Bang_ListEnd(HWND caller, LPCSTR args);
	static void Bang_ListStart(HWND caller, LPCSTR args);
	static void Bang_MainMenuPopup(HWND caller, LPCSTR args);
	static void Bang_Playlist(HWND caller, LPCSTR args);
	static void Bang_SelectSkin(HWND caller, LPCSTR args);
	static void Bang_SetPanning(HWND caller, LPCSTR args);
	static void Bang_SetVolume(HWND caller, LPCSTR args);
	static void Bang_ShadeBoth(HWND caller, LPCSTR args);
	static void Bang_ShadePlaylist(HWND caller, LPCSTR args);
	static void Bang_StartPlugin(HWND caller, LPCSTR args);
	static void Bang_StopPlugin(HWND caller, LPCSTR args);
	static void Bang_ToggleBrowser(HWND caller, LPCSTR args);
	static void Bang_VisSetup(HWND caller, LPCSTR args);
	static void Bang_WindowShade(HWND caller, LPCSTR args);
	static void Bang_Rew(HWND caller, LPCSTR args);
	static void Bang_HighPriority(HWND caller, LPCSTR args);
	static void Bang_LoadEQPreset(HWND caller, LPCSTR args);
	static void Bang_PlayPause(HWND caller, LPCSTR args);
	static void Bang_Ffwd10s(HWND caller, LPCSTR args);
	static void Bang_Ffwd20s(HWND caller, LPCSTR args);
	static void Bang_Rew10s(HWND caller, LPCSTR args);
	static void Bang_Rew20s(HWND caller, LPCSTR args);
	static void Bang_Restart(HWND caller, LPCSTR args);
	static void Bang_EditID3(HWND caller, LPCSTR args);

	//static void Bang_MovePosition(HWND caller, LPCSTR args);

	//void fileInfo();

	// These are the main processing functions...

	// Moves position backwards
	static void MoveNegative(int amount);

	// Moves position forwards
	static void MovePositive(int amount);

	static void plSendKey(char ckey);
	static HWND getWA2PE();

protected:
	char song_title[MAX_LINE_LENGTH], *p, fileProp[MAX_LINE_LENGTH], chan[7];
	int bitrate, samplerate, channels;

	BangManager Wa2Bangs;
};

#endif