#ifndef __WINAMP3_H
#define __WINAMP3_H

#include "player.h"
#include "../VTK/BangManager.h"

#define WC_WINAMP3 "Studio"


#define WA3_PREVSONG	'z'
#define WA3_PLAY		'x'
#define WA3_PAUSE		'c'
#define WA3_STOP		'v'
#define WA3_NEXTSONG	'b'

#define WA3_FILEPLAY	'l'
#define WA3_REPEAT		'r'
#define WA3_SHUFFLE		's'

#define WA3_CROSSFADE	'f'
#define WA3_JUMPTOFILE	'j'

// shift +
#define WA3_LOADDIR		'l'

// alt +
#define WA3_EDITID3		'3'

// ctrl +
#define WA3_ONTOP		'a' 
#define WA3_OPENLOC		'l'
#define WA3_DOUBLESIZE	'd'
#define WA3_PREFS		'p'

// vkey
#define WA3_RELOADSKIN	VK_F5
#define WA3_FFWD5S		VK_RIGHT
#define WA3_RWD5S		VK_LEFT
#define WA3_VOLUMEUP	VK_UP
#define WA3_VOLUMEDOWN	VK_DOWN

// class for handling wa3

class wa3 : public Player
{
public:
	wa3();
	~wa3();

	HWND GetPlayerWnd();
	void powerOff();

	void repeat();
	void shuffle();

	void prev();
	void play();
	void pause();
	void stop();
	void next();

	void volumeUp();
	void volumeDown();
	void forward5s();
	void rewind5s();

	void loadDir();
	void prefs();

	void onTop();
	void loadFile();

	// specific commands:
	// through JWinamp3
	static void Bang_JumpToFile(HWND caller, LPCSTR args);

	static void Bang_OpenLoc(HWND caller, LPCSTR args);

	static void Bang_CrossFade(HWND caller, LPCSTR args);

	static void Bang_ReloadSkin(HWND caller, LPCSTR args);

	// no idea why wa3 doesn't respond to this one...
	static void Bang_DoubleSize(HWND caller, LPCSTR args);

	static void Bang_EditID3(HWND caller, LPCSTR args);

	static void Bang_ListStart(HWND caller, LPCSTR args);

	static void Bang_ListEnd(HWND caller, LPCSTR args);

	static void plSendVKey(short vkey);

	static void plSendKey(char ckey);

	// find PL handle
	static HWND getPlaylist();

protected:
	void wa3vKeySequence(short vkey);
	void wa3KeySequence(char ckey);
	void wa3KeySequence(char ckey, const int mod);
	bool JumpFileInstalled();

	BangManager Wa3Bangs;
};

#endif
